package dfki.rdf.ruleml;

import java.util.*;


public class Prolog {

  static public String variable(String name) {
    if (name == null || name.equals(""))
      return "_"; // ???
    // INCOMPLETE: remove illegal characters ... !!!
    char c = name.charAt(0);
    if (Character.isUpperCase(c) || c == '_')
      return name;
    else
      return "_" + name;
  }

  static public String symbol(String name) {
    if (name == null || name.equals(""))
      return "''"; // ???
    boolean quotesNeeded = false;
    for (int i = 0; i < name.length(); i++) {
      char c = name.charAt(i);
      if (!(Character.isLetterOrDigit(c) || c == '_'))
	quotesNeeded = true;
    }
    char c = name.charAt(0);
    if (Character.isUpperCase(c) || Character.isDigit(c) || c == '_')
      quotesNeeded = true;
    // INCOMPLETE: double ' ... !!!
    if (quotesNeeded)
      return "'" + name + "'";
    else
      return name;
  }

  static public String psymbol(String name) { // predicate symbol
    if (builtin(name))
      return name + "_";
    else
      return symbol(name);
  }

  static boolean builtin(String p) {
    return p.equals("see") ||
      p.equals("seeing") ||
      p.equals("seen") ||
      p.equals("tell") ||
      p.equals("telling") ||
      p.equals("told") ||
      p.equals("open") ||
      p.equals("close") ||
      p.equals("get") ||
      p.equals("put") ||
      p.equals("tab") ||
      p.equals("read") ||
      p.equals("write") ||
      p.equals("writeln") ||
      p.equals("display") ||
      p.equals("not") ||
      p.equals("halt") ||
      p.equals("shell") ||
      p.equals("ls") ||
      p.equals("call");
      // to be continued ...
  }

}


