package dfki.rdf.ruleml;

import java.util.*;
import org.w3c.rdf.model.*;
import dfki.rdf.utils.*;


public class RDF2RuleML {

  public static void main(String args[]) {
    // arg 1: rdf file

    if (args.length >= 1) {

      String rdfFilename = args[0];
      String namespace = "http://www.ruleml.org/rdf#";
      String pkg = "dfki.rdf.ruleml.language";
      // String namespace = args[1];
      // String pkg = args[2];

      Map objects = (new RDFImport(namespace, pkg)).importObjects(rdfFilename);
      ArrayList rulebases = new ArrayList();

      for (Iterator objIterator = objects.values().iterator(); 
	   objIterator.hasNext();) {
	Object object = objIterator.next();
	if (object instanceof dfki.rdf.ruleml.language.Rulebase) {
	  rulebases.add(object);
	  System.out.println(object);
	}
      }

      // export test

      String exportFilename = rdfFilename + ".exported";
      (new RDFExport(namespace)).exportObjects(rulebases, exportFilename);
      System.out.println("Exported to " + exportFilename + "\n");
      System.exit(0);

    } else {

      System.err.println("Usage: <ruleml rdf file>");

    }

  }


}


